/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.302 Revision 1.373
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.302 2008/08/17 22:21:52 opfer Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.373 2011/12/16 23:38:41 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
18inherit multilib portability 21inherit multilib portability user
19 22
20DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
24
25if has "${EAPI:-0}" 0 1 2; then
21 26
22# @FUNCTION: epause 27# @FUNCTION: epause
23# @USAGE: [seconds] 28# @USAGE: [seconds]
24# @DESCRIPTION: 29# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 31# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 33# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 34epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 36}
32 37
33# @FUNCTION: ebeep 38# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 39# @USAGE: [number of beeps]
35# @DESCRIPTION: 40# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 41# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 42# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 44# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 45ebeep() {
41 local n 46 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 49 echo -ne "\a"
47 sleep 1 52 sleep 1
48 done 53 done
49 fi 54 fi
50} 55}
51 56
57else
58
59ebeep() {
60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
61}
62
63epause() {
64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
52# @FUNCTION: ecvs_clean 82# @FUNCTION: ecvs_clean
53# @USAGE: [list of dirs] 83# @USAGE: [list of dirs]
54# @DESCRIPTION: 84# @DESCRIPTION:
55# Remove CVS directories recursiveley. Useful when a source tarball contains 85# Remove CVS directories recursiveley. Useful when a source tarball contains
56# internal CVS directories. Defaults to $PWD. 86# internal CVS directories. Defaults to $PWD.
68esvn_clean() { 98esvn_clean() {
69 [[ -z $* ]] && set -- . 99 [[ -z $* ]] && set -- .
70 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
71} 101}
72 102
73# Default directory where patches are located 103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
121}
122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
131
132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}[@]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}[${__estack_i}]}\"
147 fi
148 eval unset ${__estack_name}[${__estack_i}]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -o noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 # have to assume __ESHOPTS_SAVE__ isn't screwed with
176 # as a `declare -a` here will reset its value
177 if [[ $1 == -[su] ]] ; then
178 estack_push eshopts "$(shopt -p)"
179 [[ $# -eq 0 ]] && return 0
180 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
181 else
182 estack_push eshopts $-
183 [[ $# -eq 0 ]] && return 0
184 set "$@" || die "${FUNCNAME}: bad options to set: $*"
185 fi
186}
187
188# @FUNCTION: eshopts_pop
189# @USAGE:
190# @DESCRIPTION:
191# Restore the shell options to the state saved with the corresponding
192# eshopts_push call. See that function for more details.
193eshopts_pop() {
194 local s
195 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
196 if [[ ${s} == "shopt -"* ]] ; then
197 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
198 else
199 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
200 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
201 fi
202}
203
204# @FUNCTION: eumask_push
205# @USAGE: <new umask>
206# @DESCRIPTION:
207# Set the umask to the new value specified while saving the previous
208# value onto a stack. Useful for temporarily changing the umask.
209eumask_push() {
210 estack_push eumask "$(umask)"
211 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
212}
213
214# @FUNCTION: eumask_pop
215# @USAGE:
216# @DESCRIPTION:
217# Restore the previous umask state.
218eumask_pop() {
219 local s
220 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
221 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
222}
223
224# @VARIABLE: EPATCH_SOURCE
225# @DESCRIPTION:
226# Default directory to search for patches.
74EPATCH_SOURCE="${WORKDIR}/patch" 227EPATCH_SOURCE="${WORKDIR}/patch"
75# Default extension for patches 228# @VARIABLE: EPATCH_SUFFIX
229# @DESCRIPTION:
230# Default extension for patches (do not prefix the period yourself).
76EPATCH_SUFFIX="patch.bz2" 231EPATCH_SUFFIX="patch.bz2"
232# @VARIABLE: EPATCH_OPTS
233# @DESCRIPTION:
77# Default options for patch 234# Default options for patch:
235# @CODE
78# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 236# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
79# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 237# --no-backup-if-mismatch - do not leave .orig files behind
80# Set -E to automatically remove empty files. 238# -E - automatically remove empty files
239# @CODE
81EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 240EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
241# @VARIABLE: EPATCH_EXCLUDE
242# @DESCRIPTION:
82# List of patches not to apply. Not this is only file names, 243# List of patches not to apply. Note this is only file names,
83# and not the full path .. 244# and not the full path. Globs accepted.
84EPATCH_EXCLUDE="" 245EPATCH_EXCLUDE=""
246# @VARIABLE: EPATCH_SINGLE_MSG
247# @DESCRIPTION:
85# Change the printed message for a single patch. 248# Change the printed message for a single patch.
86EPATCH_SINGLE_MSG="" 249EPATCH_SINGLE_MSG=""
250# @VARIABLE: EPATCH_MULTI_MSG
251# @DESCRIPTION:
87# Change the printed message for multiple patches. 252# Change the printed message for multiple patches.
88EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 253EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
89# Force applying bulk patches even if not following the style: 254# @VARIABLE: EPATCH_FORCE
90# 255# @DESCRIPTION:
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 256# Only require patches to match EPATCH_SUFFIX rather than the extended
92# 257# arch naming style.
93EPATCH_FORCE="no" 258EPATCH_FORCE="no"
94 259
95# This function is for bulk patching, or in theory for just one 260# @FUNCTION: epatch
96# or two patches. 261# @USAGE: [patches] [dirs of patches]
262# @DESCRIPTION:
263# epatch is designed to greatly simplify the application of patches. It can
264# process patch files directly, or directories of patches. The patches may be
265# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
266# the -p option as epatch will automatically attempt -p0 to -p5 until things
267# apply successfully.
97# 268#
98# It should work with .bz2, .gz, .zip and plain text patches. 269# If you do not specify any options, then epatch will default to the directory
99# Currently all patches should be the same format. 270# specified by EPATCH_SOURCE.
100# 271#
101# You do not have to specify '-p' option to patch, as it will 272# When processing directories, epatch will apply all patches that match:
102# try with -p0 to -p5 until it succeed, or fail at -p5. 273# @CODE
103# 274# if ${EPATCH_FORCE} != "yes"
104# Above EPATCH_* variables can be used to control various defaults,
105# bug they should be left as is to ensure an ebuild can rely on
106# them for.
107#
108# Patches are applied in current directory.
109#
110# Bulk Patches should preferibly have the form of:
111#
112# ??_${ARCH}_foo.${EPATCH_SUFFIX} 275# ??_${ARCH}_foo.${EPATCH_SUFFIX}
276# else
277# *.${EPATCH_SUFFIX}
278# @CODE
279# The leading ?? are typically numbers used to force consistent patch ordering.
280# The arch field is used to apply patches only for the host architecture with
281# the special value of "all" means apply for everyone. Note that using values
282# other than "all" is highly discouraged -- you should apply patches all the
283# time and let architecture details be detected at configure/compile time.
113# 284#
114# For example: 285# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
286# for patches to apply.
115# 287#
116# 01_all_misc-fix.patch.bz2 288# Refer to the other EPATCH_xxx variables for more customization of behavior.
117# 02_sparc_another-fix.patch.bz2
118#
119# This ensures that there are a set order, and you can have ARCH
120# specific patches.
121#
122# If you however give an argument to epatch(), it will treat it as a
123# single patch that need to be applied if its a file. If on the other
124# hand its a directory, it will set EPATCH_SOURCE to this.
125#
126# <azarah@gentoo.org> (10 Nov 2002)
127#
128epatch() { 289epatch() {
129 _epatch_draw_line() { 290 _epatch_draw_line() {
291 # create a line of same length as input string
130 [[ -z $1 ]] && set "$(printf "%65s" '')" 292 [[ -z $1 ]] && set "$(printf "%65s" '')"
131 echo "${1//?/=}" 293 echo "${1//?/=}"
132 } 294 }
133 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
134 local PIPE_CMD=""
135 local STDERR_TARGET="${T}/$$.out"
136 local PATCH_TARGET="${T}/$$.patch"
137 local PATCH_SUFFIX=""
138 local SINGLE_PATCH="no"
139 local x=""
140 295
141 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 296 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
142 297
143 if [ "$#" -gt 1 ] 298 # Let the rest of the code process one user arg at a time --
144 then 299 # each arg may expand into multiple patches, and each arg may
300 # need to start off with the default global EPATCH_xxx values
301 if [[ $# -gt 1 ]] ; then
145 local m="" 302 local m
146 for m in "$@" ; do 303 for m in "$@" ; do
147 epatch "${m}" 304 epatch "${m}"
148 done 305 done
149 return 0 306 return 0
150 fi 307 fi
151 308
152 if [ -n "$1" -a -f "$1" ] 309 local SINGLE_PATCH="no"
153 then 310 # no args means process ${EPATCH_SOURCE}
311 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
312
313 if [[ -f $1 ]] ; then
154 SINGLE_PATCH="yes" 314 SINGLE_PATCH="yes"
155 315 set -- "$1"
156 local EPATCH_SOURCE="$1" 316 # Use the suffix from the single patch (localize it); the code
317 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 318 local EPATCH_SUFFIX=$1
158 319
159 elif [ -n "$1" -a -d "$1" ] 320 elif [[ -d $1 ]] ; then
160 then 321 # Some people like to make dirs of patches w/out suffixes (vim)
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 322 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 323
324 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
325 # Re-use EPATCH_SOURCE as a search dir
326 epatch "${EPATCH_SOURCE}/$1"
327 return $?
328
329 else
330 # sanity check ... if it isn't a dir or file, wtf man ?
331 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
332 echo
333 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
334 eerror
335 eerror " ${EPATCH_SOURCE}"
336 eerror " ( ${EPATCH_SOURCE##*/} )"
337 echo
338 die "Cannot find \$EPATCH_SOURCE!"
339 fi
340
341 local PIPE_CMD
342 case ${EPATCH_SUFFIX##*\.} in
343 xz) PIPE_CMD="xz -dc" ;;
344 lzma) PIPE_CMD="lzma -dc" ;;
345 bz2) PIPE_CMD="bzip2 -dc" ;;
346 gz|Z|z) PIPE_CMD="gzip -dc" ;;
347 ZIP|zip) PIPE_CMD="unzip -p" ;;
348 *) ;;
349 esac
350
351 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
352
353 local x
354 for x in "$@" ; do
355 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
356 # didn't match anything, ignore continue on
357 [[ ! -f ${x} ]] && continue
358
359 local patchname=${x##*/}
360
361 # Apply single patches, or forced sets of patches, or
362 # patches with ARCH dependant names.
363 # ???_arch_foo.patch
364 # Else, skip this input altogether
365 local a=${patchname#*_} # strip the ???_
366 a=${a%%_*} # strip the _foo.patch
367 if ! [[ ${SINGLE_PATCH} == "yes" || \
368 ${EPATCH_FORCE} == "yes" || \
369 ${a} == all || \
370 ${a} == ${ARCH} ]]
163 then 371 then
164 local EPATCH_SOURCE="$1/*" 372 continue
373 fi
374
375 # Let people filter things dynamically
376 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
377 # let people use globs in the exclude
378 eshopts_push -o noglob
379
380 local ex
381 for ex in ${EPATCH_EXCLUDE} ; do
382 if [[ ${patchname} == ${ex} ]] ; then
383 eshopts_pop
384 continue 2
385 fi
386 done
387
388 eshopts_pop
389 fi
390
391 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
392 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
393 einfo "${EPATCH_SINGLE_MSG}"
394 else
395 einfo "Applying ${patchname} ..."
396 fi
165 else 397 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 398 einfo " ${patchname} ..."
167 fi 399 fi
168 else 400
169 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 401 # most of the time, there will only be one run per unique name,
170 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 402 # but if there are more, make sure we get unique log filenames
171 then 403 local STDERR_TARGET="${T}/${patchname}.out"
172 EPATCH_SOURCE="$1" 404 if [[ -e ${STDERR_TARGET} ]] ; then
405 STDERR_TARGET="${T}/${patchname}-$$.out"
406 fi
407
408 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
409
410 # Decompress the patch if need be
411 local count=0
412 local PATCH_TARGET
413 if [[ -n ${PIPE_CMD} ]] ; then
414 PATCH_TARGET="${T}/$$.patch"
415 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
416
417 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
418 echo
419 eerror "Could not extract patch!"
420 #die "Could not extract patch!"
421 count=5
422 break
173 fi 423 fi
424 else
425 PATCH_TARGET=${x}
426 fi
174 427
428 # Check for absolute paths in patches. If sandbox is disabled,
429 # people could (accidently) patch files in the root filesystem.
430 # Or trigger other unpleasantries #237667. So disallow -p0 on
431 # such patches.
432 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
433 if [[ -n ${abs_paths} ]] ; then
434 count=1
435 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
436 fi
437 # Similar reason, but with relative paths.
438 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
439 if [[ -n ${rel_paths} ]] ; then
440 eqawarn "QA Notice: Your patch uses relative paths '../'."
441 eqawarn " In the future this will cause a failure."
442 eqawarn "${rel_paths}"
443 fi
444
445 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
446 while [[ ${count} -lt 5 ]] ; do
447 # Generate some useful debug info ...
448 (
449 _epatch_draw_line "***** ${patchname} *****"
175 echo 450 echo
176 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 451 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
452 echo
453 _epatch_draw_line "***** ${patchname} *****"
454 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
455 ret=$?
456 echo
457 echo "patch program exited with status ${ret}"
458 exit ${ret}
459 ) >> "${STDERR_TARGET}"
460
461 if [ $? -eq 0 ] ; then
462 (
463 _epatch_draw_line "***** ${patchname} *****"
464 echo
465 echo "ACTUALLY APPLYING ${patchname} ..."
466 echo
467 _epatch_draw_line "***** ${patchname} *****"
468 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
469 ret=$?
470 echo
471 echo "patch program exited with status ${ret}"
472 exit ${ret}
473 ) >> "${STDERR_TARGET}"
474
475 if [ $? -ne 0 ] ; then
476 echo
477 eerror "A dry-run of patch command succeeded, but actually"
478 eerror "applying the patch failed!"
479 #die "Real world sux compared to the dreamworld!"
480 count=5
481 fi
482 break
483 fi
484
485 : $(( count++ ))
486 done
487
488 # if we had to decompress the patch, delete the temp one
489 if [[ -n ${PIPE_CMD} ]] ; then
490 rm -f "${PATCH_TARGET}"
491 fi
492
493 if [[ ${count} -ge 5 ]] ; then
494 echo
495 eerror "Failed Patch: ${patchname} !"
496 eerror " ( ${PATCH_TARGET} )"
177 eerror 497 eerror
178 eerror " ${EPATCH_SOURCE}" 498 eerror "Include in your bugreport the contents of:"
179 eerror " ( ${EPATCH_SOURCE##*/} )" 499 eerror
500 eerror " ${STDERR_TARGET}"
180 echo 501 echo
181 die "Cannot find \$EPATCH_SOURCE!"
182 fi
183
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
185 fi
186
187 case ${EPATCH_SUFFIX##*\.} in
188 bz2)
189 PIPE_CMD="bzip2 -dc"
190 PATCH_SUFFIX="bz2"
191 ;;
192 gz|Z|z)
193 PIPE_CMD="gzip -dc"
194 PATCH_SUFFIX="gz"
195 ;;
196 ZIP|zip)
197 PIPE_CMD="unzip -p"
198 PATCH_SUFFIX="zip"
199 ;;
200 *)
201 PIPE_CMD="cat"
202 PATCH_SUFFIX="patch"
203 ;;
204 esac
205
206 if [ "${SINGLE_PATCH}" = "no" ]
207 then
208 einfo "${EPATCH_MULTI_MSG}"
209 fi
210 for x in ${EPATCH_SOURCE}
211 do
212 # New ARCH dependant patch naming scheme ...
213 #
214 # ???_arch_foo.patch
215 #
216 if [ -f ${x} ] && \
217 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
218 [ "${EPATCH_FORCE}" = "yes" ])
219 then
220 local count=0
221 local popts="${EPATCH_OPTS}"
222 local patchname=${x##*/}
223
224 if [ -n "${EPATCH_EXCLUDE}" ]
225 then
226 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
227 then
228 continue
229 fi
230 fi
231
232 if [ "${SINGLE_PATCH}" = "yes" ]
233 then
234 if [ -n "${EPATCH_SINGLE_MSG}" ]
235 then
236 einfo "${EPATCH_SINGLE_MSG}"
237 else
238 einfo "Applying ${patchname} ..."
239 fi
240 else
241 einfo " ${patchname} ..."
242 fi
243
244 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
245 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246
247 # Allow for prefix to differ ... im lazy, so shoot me :/
248 while [ "${count}" -lt 5 ]
249 do
250 # Generate some useful debug info ...
251 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
252 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
253
254 if [ "${PATCH_SUFFIX}" != "patch" ]
255 then
256 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
257 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
258 else
259 PATCH_TARGET="${x}"
260 fi
261
262 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
264
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
267
268 if [ "${PATCH_SUFFIX}" != "patch" ]
269 then
270 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
271 then
272 echo
273 eerror "Could not extract patch!"
274 #die "Could not extract patch!"
275 count=5
276 break
277 fi
278 fi
279
280 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
281 then
282 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
283 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
284 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
285 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
286 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
287
288 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
289 _epatch_assert
290
291 if [ "$?" -ne 0 ]
292 then
293 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
294 echo
295 eerror "A dry-run of patch command succeeded, but actually"
296 eerror "applying the patch failed!"
297 #die "Real world sux compared to the dreamworld!"
298 count=5
299 fi
300
301 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302
303 break
304 fi
305
306 count=$((count + 1))
307 done
308
309 if [ "${PATCH_SUFFIX}" != "patch" ]
310 then
311 rm -f ${PATCH_TARGET}
312 fi
313
314 if [ "${count}" -eq 5 ]
315 then
316 echo
317 eerror "Failed Patch: ${patchname} !"
318 eerror " ( ${PATCH_TARGET} )"
319 eerror
320 eerror "Include in your bugreport the contents of:"
321 eerror
322 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
323 echo
324 die "Failed Patch: ${patchname}!" 502 die "Failed Patch: ${patchname}!"
325 fi 503 fi
326 504
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 505 # if everything worked, delete the patch log
328 506 rm -f "${STDERR_TARGET}"
329 eend 0 507 eend 0
330 fi
331 done 508 done
332 if [ "${SINGLE_PATCH}" = "no" ] 509
333 then 510 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
334 einfo "Done with patching" 511 : # everything worked
512}
513
514# @FUNCTION: epatch_user
515# @USAGE:
516# @DESCRIPTION:
517# Applies user-provided patches to the source tree. The patches are
518# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
519# of these three directories to exist will be the one to use, ignoring
520# any more general directories which might exist as well.
521#
522# User patches are intended for quick testing of patches without ebuild
523# modifications, as well as for permanent customizations a user might
524# desire. Obviously, there can be no official support for arbitrarily
525# patched ebuilds. So whenever a build log in a bug report mentions that
526# user patches were applied, the user should be asked to reproduce the
527# problem without these.
528#
529# Not all ebuilds do call this function, so placing patches in the
530# stated directory might or might not work, depending on the package and
531# the eclasses it inherits and uses. It is safe to call the function
532# repeatedly, so it is always possible to add a call at the ebuild
533# level. The first call is the time when the patches will be
534# applied.
535#
536# Ideally, this function should be called after gentoo-specific patches
537# have been applied, so that their code can be modified as well, but
538# before calls to e.g. eautoreconf, as the user patches might affect
539# autotool input files as well.
540epatch_user() {
541 [[ $# -ne 0 ]] && die "epatch_user takes no options"
542
543 # Allow multiple calls to this function; ignore all but the first
544 local applied="${T}/epatch_user.applied"
545 [[ -e ${applied} ]] && return 2
546
547 # don't clobber any EPATCH vars that the parent might want
548 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
549 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
550 EPATCH_SOURCE=${base}/${CTARGET}/${check}
551 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
552 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
553 if [[ -d ${EPATCH_SOURCE} ]] ; then
554 EPATCH_SOURCE=${EPATCH_SOURCE} \
555 EPATCH_SUFFIX="patch" \
556 EPATCH_FORCE="yes" \
557 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
558 epatch
559 echo "${EPATCH_SOURCE}" > "${applied}"
560 return 0
335 fi 561 fi
562 done
563 echo "none" > "${applied}"
564 return 1
336} 565}
337 566
338# @FUNCTION: emktemp 567# @FUNCTION: emktemp
339# @USAGE: [temp dir] 568# @USAGE: [temp dir]
340# @DESCRIPTION: 569# @DESCRIPTION:
368 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 597 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
369 fi 598 fi
370 fi 599 fi
371} 600}
372 601
373# @FUNCTION: egetent
374# @USAGE: <database> <key>
375# @MAINTAINER:
376# base-system@gentoo.org (Linux)
377# Joe Jezak <josejx@gmail.com> (OS X)
378# usata@gentoo.org (OS X)
379# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
380# @DESCRIPTION:
381# Small wrapper for getent (Linux), nidump (Mac OS X),
382# and pw (FreeBSD) used in enewuser()/enewgroup()
383egetent() {
384 case ${CHOST} in
385 *-darwin*)
386 case "$2" in
387 *[!0-9]*) # Non numeric
388 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
389 ;;
390 *) # Numeric
391 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
392 ;;
393 esac
394 ;;
395 *-freebsd*|*-dragonfly*)
396 local opts action="user"
397 [[ $1 == "passwd" ]] || action="group"
398
399 # lookup by uid/gid
400 if [[ $2 == [[:digit:]]* ]] ; then
401 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
402 fi
403
404 pw show ${action} ${opts} "$2" -q
405 ;;
406 *-netbsd*|*-openbsd*)
407 grep "$2:\*:" /etc/$1
408 ;;
409 *)
410 type -p nscd >& /dev/null && nscd -i "$1"
411 getent "$1" "$2"
412 ;;
413 esac
414}
415
416# @FUNCTION: enewuser
417# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
418# @DESCRIPTION:
419# Same as enewgroup, you are not required to understand how to properly add
420# a user to the system. The only required parameter is the username.
421# Default uid is (pass -1 for this) next available, default shell is
422# /bin/false, default homedir is /dev/null, there are no default groups,
423# and default params sets the comment as 'added by portage for ${PN}'.
424enewuser() {
425 case ${EBUILD_PHASE} in
426 unpack|compile|test|install)
427 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
428 eerror "Package fails at QA and at life. Please file a bug."
429 die "Bad package! enewuser is only for use in pkg_* functions!"
430 esac
431
432 # get the username
433 local euser=$1; shift
434 if [[ -z ${euser} ]] ; then
435 eerror "No username specified !"
436 die "Cannot call enewuser without a username"
437 fi
438
439 # lets see if the username already exists
440 if [[ -n $(egetent passwd "${euser}") ]] ; then
441 return 0
442 fi
443 einfo "Adding user '${euser}' to your system ..."
444
445 # options to pass to useradd
446 local opts=
447
448 # handle uid
449 local euid=$1; shift
450 if [[ -n ${euid} && ${euid} != -1 ]] ; then
451 if [[ ${euid} -gt 0 ]] ; then
452 if [[ -n $(egetent passwd ${euid}) ]] ; then
453 euid="next"
454 fi
455 else
456 eerror "Userid given but is not greater than 0 !"
457 die "${euid} is not a valid UID"
458 fi
459 else
460 euid="next"
461 fi
462 if [[ ${euid} == "next" ]] ; then
463 for ((euid = 101; euid <= 999; euid++)); do
464 [[ -z $(egetent passwd ${euid}) ]] && break
465 done
466 fi
467 opts="${opts} -u ${euid}"
468 einfo " - Userid: ${euid}"
469
470 # handle shell
471 local eshell=$1; shift
472 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
473 if [[ ! -e ${ROOT}${eshell} ]] ; then
474 eerror "A shell was specified but it does not exist !"
475 die "${eshell} does not exist in ${ROOT}"
476 fi
477 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
478 eerror "Do not specify ${eshell} yourself, use -1"
479 die "Pass '-1' as the shell parameter"
480 fi
481 else
482 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
483 [[ -x ${ROOT}${shell} ]] && break
484 done
485
486 if [[ ${shell} == "/dev/null" ]] ; then
487 eerror "Unable to identify the shell to use, proceeding with userland default."
488 case ${USERLAND} in
489 GNU) shell="/bin/false" ;;
490 BSD) shell="/sbin/nologin" ;;
491 Darwin) shell="/usr/sbin/nologin" ;;
492 *) die "Unable to identify the default shell for userland ${USERLAND}"
493 esac
494 fi
495
496 eshell=${shell}
497 fi
498 einfo " - Shell: ${eshell}"
499 opts="${opts} -s ${eshell}"
500
501 # handle homedir
502 local ehome=$1; shift
503 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
504 ehome="/dev/null"
505 fi
506 einfo " - Home: ${ehome}"
507 opts="${opts} -d ${ehome}"
508
509 # handle groups
510 local egroups=$1; shift
511 if [[ ! -z ${egroups} ]] ; then
512 local oldifs=${IFS}
513 local defgroup="" exgroups=""
514
515 export IFS=","
516 for g in ${egroups} ; do
517 export IFS=${oldifs}
518 if [[ -z $(egetent group "${g}") ]] ; then
519 eerror "You must add group ${g} to the system first"
520 die "${g} is not a valid GID"
521 fi
522 if [[ -z ${defgroup} ]] ; then
523 defgroup=${g}
524 else
525 exgroups="${exgroups},${g}"
526 fi
527 export IFS=","
528 done
529 export IFS=${oldifs}
530
531 opts="${opts} -g ${defgroup}"
532 if [[ ! -z ${exgroups} ]] ; then
533 opts="${opts} -G ${exgroups:1}"
534 fi
535 else
536 egroups="(none)"
537 fi
538 einfo " - Groups: ${egroups}"
539
540 # handle extra and add the user
541 local oldsandbox=${SANDBOX_ON}
542 export SANDBOX_ON="0"
543 case ${CHOST} in
544 *-darwin*)
545 ### Make the user
546 if [[ -z $@ ]] ; then
547 dscl . create /users/${euser} uid ${euid}
548 dscl . create /users/${euser} shell ${eshell}
549 dscl . create /users/${euser} home ${ehome}
550 dscl . create /users/${euser} realname "added by portage for ${PN}"
551 ### Add the user to the groups specified
552 local oldifs=${IFS}
553 export IFS=","
554 for g in ${egroups} ; do
555 dscl . merge /groups/${g} users ${euser}
556 done
557 export IFS=${oldifs}
558 else
559 einfo "Extra options are not supported on Darwin yet"
560 einfo "Please report the ebuild along with the info below"
561 einfo "eextra: $@"
562 die "Required function missing"
563 fi
564 ;;
565 *-freebsd*|*-dragonfly*)
566 if [[ -z $@ ]] ; then
567 pw useradd ${euser} ${opts} \
568 -c "added by portage for ${PN}" \
569 die "enewuser failed"
570 else
571 einfo " - Extra: $@"
572 pw useradd ${euser} ${opts} \
573 "$@" || die "enewuser failed"
574 fi
575 ;;
576
577 *-netbsd*)
578 if [[ -z $@ ]] ; then
579 useradd ${opts} ${euser} || die "enewuser failed"
580 else
581 einfo " - Extra: $@"
582 useradd ${opts} ${euser} "$@" || die "enewuser failed"
583 fi
584 ;;
585
586 *-openbsd*)
587 if [[ -z $@ ]] ; then
588 useradd -u ${euid} -s ${eshell} \
589 -d ${ehome} -c "Added by portage for ${PN}" \
590 -g ${egroups} ${euser} || die "enewuser failed"
591 else
592 einfo " - Extra: $@"
593 useradd -u ${euid} -s ${eshell} \
594 -d ${ehome} -c "Added by portage for ${PN}" \
595 -g ${egroups} ${euser} "$@" || die "enewuser failed"
596 fi
597 ;;
598
599 *)
600 if [[ -z $@ ]] ; then
601 useradd ${opts} ${euser} \
602 -c "added by portage for ${PN}" \
603 || die "enewuser failed"
604 else
605 einfo " - Extra: $@"
606 useradd ${opts} ${euser} "$@" \
607 || die "enewuser failed"
608 fi
609 ;;
610 esac
611
612 if [[ ! -e ${ROOT}/${ehome} ]] ; then
613 einfo " - Creating ${ehome} in ${ROOT}"
614 mkdir -p "${ROOT}/${ehome}"
615 chown ${euser} "${ROOT}/${ehome}"
616 chmod 755 "${ROOT}/${ehome}"
617 fi
618
619 export SANDBOX_ON=${oldsandbox}
620}
621
622# @FUNCTION: enewgroup
623# @USAGE: <group> [gid]
624# @DESCRIPTION:
625# This function does not require you to understand how to properly add a
626# group to the system. Just give it a group name to add and enewgroup will
627# do the rest. You may specify the gid for the group or allow the group to
628# allocate the next available one.
629enewgroup() {
630 case ${EBUILD_PHASE} in
631 unpack|compile|test|install)
632 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
633 eerror "Package fails at QA and at life. Please file a bug."
634 die "Bad package! enewgroup is only for use in pkg_* functions!"
635 esac
636
637 # get the group
638 local egroup="$1"; shift
639 if [ -z "${egroup}" ]
640 then
641 eerror "No group specified !"
642 die "Cannot call enewgroup without a group"
643 fi
644
645 # see if group already exists
646 if [[ -n $(egetent group "${egroup}") ]]; then
647 return 0
648 fi
649 einfo "Adding group '${egroup}' to your system ..."
650
651 # options to pass to useradd
652 local opts=
653
654 # handle gid
655 local egid="$1"; shift
656 if [ ! -z "${egid}" ]
657 then
658 if [ "${egid}" -gt 0 ]
659 then
660 if [ -z "`egetent group ${egid}`" ]
661 then
662 if [[ "${CHOST}" == *-darwin* ]]; then
663 opts="${opts} ${egid}"
664 else
665 opts="${opts} -g ${egid}"
666 fi
667 else
668 egid="next available; requested gid taken"
669 fi
670 else
671 eerror "Groupid given but is not greater than 0 !"
672 die "${egid} is not a valid GID"
673 fi
674 else
675 egid="next available"
676 fi
677 einfo " - Groupid: ${egid}"
678
679 # handle extra
680 local eextra="$@"
681 opts="${opts} ${eextra}"
682
683 # add the group
684 local oldsandbox="${SANDBOX_ON}"
685 export SANDBOX_ON="0"
686 case ${CHOST} in
687 *-darwin*)
688 if [ ! -z "${eextra}" ];
689 then
690 einfo "Extra options are not supported on Darwin/OS X yet"
691 einfo "Please report the ebuild along with the info below"
692 einfo "eextra: ${eextra}"
693 die "Required function missing"
694 fi
695
696 # If we need the next available
697 case ${egid} in
698 *[!0-9]*) # Non numeric
699 for ((egid = 101; egid <= 999; egid++)); do
700 [[ -z $(egetent group ${egid}) ]] && break
701 done
702 esac
703 dscl . create /groups/${egroup} gid ${egid}
704 dscl . create /groups/${egroup} passwd '*'
705 ;;
706
707 *-freebsd*|*-dragonfly*)
708 case ${egid} in
709 *[!0-9]*) # Non numeric
710 for ((egid = 101; egid <= 999; egid++)); do
711 [[ -z $(egetent group ${egid}) ]] && break
712 done
713 esac
714 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
715 ;;
716
717 *-netbsd*)
718 case ${egid} in
719 *[!0-9]*) # Non numeric
720 for ((egid = 101; egid <= 999; egid++)); do
721 [[ -z $(egetent group ${egid}) ]] && break
722 done
723 esac
724 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
725 ;;
726
727 *)
728 groupadd ${opts} ${egroup} || die "enewgroup failed"
729 ;;
730 esac
731 export SANDBOX_ON="${oldsandbox}"
732}
733
734# @FUNCTION: edos2unix 602# @FUNCTION: edos2unix
735# @USAGE: <file> [more files ...] 603# @USAGE: <file> [more files ...]
736# @DESCRIPTION: 604# @DESCRIPTION:
737# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 605# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
738# to remove all of these text utilities from DEPEND variables because this 606# to remove all of these text utilities from DEPEND variables because this
739# is a script based solution. Just give it a list of files to convert and 607# is a script based solution. Just give it a list of files to convert and
740# they will all be changed from the DOS CRLF format to the UNIX LF format. 608# they will all be changed from the DOS CRLF format to the UNIX LF format.
741edos2unix() { 609edos2unix() {
742 echo "$@" | xargs sed -i 's/\r$//' 610 [[ $# -eq 0 ]] && return 0
611 sed -i 's/\r$//' -- "$@" || die
743} 612}
744 613
745# Make a desktop file ! 614# Make a desktop file !
746# Great for making those icons in kde/gnome startmenu ! 615# Great for making those icons in kde/gnome startmenu !
747# Amaze your friends ! Get the women ! Join today ! 616# Amaze your friends ! Get the women ! Join today !
748# 617#
749# make_desktop_entry(<command>, [name], [icon], [type], [path]) 618# make_desktop_entry(<command>, [name], [icon], [type], [fields])
750# 619#
751# binary: what command does the app run with ? 620# binary: what command does the app run with ?
752# name: the name that will show up in the menu 621# name: the name that will show up in the menu
753# icon: give your little like a pretty little icon ... 622# icon: give your little like a pretty little icon ...
754# this can be relative (to /usr/share/pixmaps) or 623# this can be relative (to /usr/share/pixmaps) or
755# a full path to an icon 624# a full path to an icon
756# type: what kind of application is this ? for categories: 625# type: what kind of application is this ? for categories:
757# http://standards.freedesktop.org/menu-spec/latest/apa.html 626# http://standards.freedesktop.org/menu-spec/latest/apa.html
758# path: if your app needs to startup in a specific dir 627# fields: extra fields to append to the desktop file; a printf string
759make_desktop_entry() { 628make_desktop_entry() {
760 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 629 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
761 630
762 local exec=${1} 631 local exec=${1}
763 local name=${2:-${PN}} 632 local name=${2:-${PN}}
764 local icon=${3:-${PN}} 633 local icon=${3:-${PN}}
765 local type=${4} 634 local type=${4}
766 local path=${5} 635 local fields=${5}
767 636
768 if [[ -z ${type} ]] ; then 637 if [[ -z ${type} ]] ; then
769 local catmaj=${CATEGORY%%-*} 638 local catmaj=${CATEGORY%%-*}
770 local catmin=${CATEGORY##*-} 639 local catmin=${CATEGORY##*-}
771 case ${catmaj} in 640 case ${catmaj} in
772 app) 641 app)
773 case ${catmin} in 642 case ${catmin} in
774 accessibility) type=Accessibility;; 643 accessibility) type=Accessibility;;
775 admin) type=System;; 644 admin) type=System;;
776 antivirus) type=System;; 645 antivirus) type=System;;
777 arch) type=Archiving;; 646 arch) type=Archiving;;
778 backup) type=Archiving;; 647 backup) type=Archiving;;
779 cdr) type=DiscBurning;; 648 cdr) type=DiscBurning;;
780 dicts) type=Dictionary;; 649 dicts) type=Dictionary;;
781 doc) type=Documentation;; 650 doc) type=Documentation;;
782 editors) type=TextEditor;; 651 editors) type=TextEditor;;
783 emacs) type=TextEditor;; 652 emacs) type=TextEditor;;
784 emulation) type=Emulator;; 653 emulation) type=Emulator;;
785 laptop) type=HardwareSettings;; 654 laptop) type=HardwareSettings;;
786 office) type=Office;; 655 office) type=Office;;
787 pda) type=PDA;; 656 pda) type=PDA;;
788 vim) type=TextEditor;; 657 vim) type=TextEditor;;
789 xemacs) type=TextEditor;; 658 xemacs) type=TextEditor;;
790 *) type=;;
791 esac 659 esac
792 ;; 660 ;;
793 661
794 dev) 662 dev)
795 type="Development" 663 type="Development"
796 ;; 664 ;;
797 665
798 games) 666 games)
799 case ${catmin} in 667 case ${catmin} in
800 action|fps) type=ActionGame;; 668 action|fps) type=ActionGame;;
801 arcade) type=ArcadeGame;; 669 arcade) type=ArcadeGame;;
802 board) type=BoardGame;; 670 board) type=BoardGame;;
803 emulation) type=Emulator;; 671 emulation) type=Emulator;;
804 kids) type=KidsGame;; 672 kids) type=KidsGame;;
805 puzzle) type=LogicGame;; 673 puzzle) type=LogicGame;;
806 roguelike) type=RolePlaying;; 674 roguelike) type=RolePlaying;;
807 rpg) type=RolePlaying;; 675 rpg) type=RolePlaying;;
808 simulation) type=Simulation;; 676 simulation) type=Simulation;;
809 sports) type=SportsGame;; 677 sports) type=SportsGame;;
810 strategy) type=StrategyGame;; 678 strategy) type=StrategyGame;;
811 *) type=;;
812 esac 679 esac
813 type="Game;${type}" 680 type="Game;${type}"
814 ;; 681 ;;
815 682
816 gnome) 683 gnome)
825 type="Network;Email" 692 type="Network;Email"
826 ;; 693 ;;
827 694
828 media) 695 media)
829 case ${catmin} in 696 case ${catmin} in
697 gfx)
830 gfx) type=Graphics;; 698 type=Graphics
699 ;;
700 *)
701 case ${catmin} in
831 radio) type=Tuner;; 702 radio) type=Tuner;;
832 sound) type=Audio;; 703 sound) type=Audio;;
833 tv) type=TV;; 704 tv) type=TV;;
834 video) type=Video;; 705 video) type=Video;;
835 *) type=;; 706 esac
707 type="AudioVideo;${type}"
708 ;;
836 esac 709 esac
837 type="AudioVideo;${type}"
838 ;; 710 ;;
839 711
840 net) 712 net)
841 case ${catmin} in 713 case ${catmin} in
842 dialup) type=Dialup;; 714 dialup) type=Dialup;;
843 ftp) type=FileTransfer;; 715 ftp) type=FileTransfer;;
844 im) type=InstantMessaging;; 716 im) type=InstantMessaging;;
845 irc) type=IRCClient;; 717 irc) type=IRCClient;;
846 mail) type=Email;; 718 mail) type=Email;;
847 news) type=News;; 719 news) type=News;;
848 nntp) type=News;; 720 nntp) type=News;;
849 p2p) type=FileTransfer;; 721 p2p) type=FileTransfer;;
850 *) type=;; 722 voip) type=Telephony;;
851 esac 723 esac
852 type="Network;${type}" 724 type="Network;${type}"
853 ;; 725 ;;
854 726
855 sci) 727 sci)
856 case ${catmin} in 728 case ${catmin} in
857 astro*) type=Astronomy;; 729 astro*) type=Astronomy;;
858 bio*) type=Biology;; 730 bio*) type=Biology;;
859 calc*) type=Calculator;; 731 calc*) type=Calculator;;
860 chem*) type=Chemistry;; 732 chem*) type=Chemistry;;
861 elec*) type=Electronics;; 733 elec*) type=Electronics;;
862 geo*) type=Geology;; 734 geo*) type=Geology;;
863 math*) type=Math;; 735 math*) type=Math;;
864 physics) type=Physics;; 736 physics) type=Physics;;
865 visual*) type=DataVisualization;; 737 visual*) type=DataVisualization;;
866 *) type=;;
867 esac 738 esac
868 type="Science;${type}" 739 type="Education;Science;${type}"
869 ;; 740 ;;
870 741
871 sys) 742 sys)
872 type="System" 743 type="System"
873 ;; 744 ;;
874 745
875 www) 746 www)
876 case ${catmin} in 747 case ${catmin} in
877 client) type=WebBrowser;; 748 client) type=WebBrowser;;
878 *) type=;;
879 esac 749 esac
880 type="Network" 750 type="Network;${type}"
881 ;; 751 ;;
882 752
883 *) 753 *)
884 type= 754 type=
885 ;; 755 ;;
891 local desktop_name="${PN}-${SLOT}" 761 local desktop_name="${PN}-${SLOT}"
892 fi 762 fi
893 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 763 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 764 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 765
766 # Don't append another ";" when a valid category value is provided.
767 type=${type%;}${type:+;}
768
769 eshopts_push -s extglob
770 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
771 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
772 ewarn "allowed in .desktop files if the value is not an absolute path."
773 icon=${icon%.@(xpm|png|svg)}
774 fi
775 eshopts_pop
776
896 cat <<-EOF > "${desktop}" 777 cat <<-EOF > "${desktop}"
897 [Desktop Entry] 778 [Desktop Entry]
898 Version=1.0
899 Name=${name} 779 Name=${name}
900 Type=Application 780 Type=Application
901 Comment=${DESCRIPTION} 781 Comment=${DESCRIPTION}
902 Exec=${exec} 782 Exec=${exec}
903 TryExec=${exec%% *} 783 TryExec=${exec%% *}
904 Icon=${icon} 784 Icon=${icon}
905 Categories=${type}; 785 Categories=${type}
906 EOF 786 EOF
907 787
908 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 788 if [[ ${fields:-=} != *=* ]] ; then
789 # 5th arg used to be value to Path=
790 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
791 fields="Path=${fields}"
792 fi
793 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
909 794
910 ( 795 (
911 # wrap the env here so that the 'insinto' call 796 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller 797 # doesn't corrupt the env of the caller
913 insinto /usr/share/applications 798 insinto /usr/share/applications
914 doins "${desktop}" 799 doins "${desktop}"
915 ) 800 ) || die "installing desktop file failed"
916} 801}
917 802
918# @FUNCTION: validate_desktop_entries 803# @FUNCTION: validate_desktop_entries
919# @USAGE: [directories] 804# @USAGE: [directories]
920# @MAINTAINER: 805# @MAINTAINER:
942 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 827 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
943 fi 828 fi
944} 829}
945 830
946# @FUNCTION: make_session_desktop 831# @FUNCTION: make_session_desktop
947# @USAGE: <title> <command> 832# @USAGE: <title> <command> [command args...]
948# @DESCRIPTION: 833# @DESCRIPTION:
949# Make a GDM/KDM Session file. The title is the file to execute to start the 834# Make a GDM/KDM Session file. The title is the file to execute to start the
950# Window Manager. The command is the name of the Window Manager. 835# Window Manager. The command is the name of the Window Manager.
836#
837# You can set the name of the file via the ${wm} variable.
951make_session_desktop() { 838make_session_desktop() {
952 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 839 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
953 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 840 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
954 841
955 local title=$1 842 local title=$1
956 local command=$2 843 local command=$2
957 local desktop=${T}/${wm}.desktop 844 local desktop=${T}/${wm:-${PN}}.desktop
845 shift 2
958 846
959 cat <<-EOF > "${desktop}" 847 cat <<-EOF > "${desktop}"
960 [Desktop Entry] 848 [Desktop Entry]
961 Name=${title} 849 Name=${title}
962 Comment=This session logs you into ${title} 850 Comment=This session logs you into ${title}
963 Exec=${command} 851 Exec=${command} $*
964 TryExec=${command} 852 TryExec=${command}
965 Type=Application 853 Type=XSession
966 EOF 854 EOF
967 855
968 ( 856 (
969 # wrap the env here so that the 'insinto' call 857 # wrap the env here so that the 'insinto' call
970 # doesn't corrupt the env of the caller 858 # doesn't corrupt the env of the caller
1196 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1084 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1197 1085
1198 local shrtsrc=$(basename "${src}") 1086 local shrtsrc=$(basename "${src}")
1199 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1087 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1200 if [[ -z ${skip} ]] ; then 1088 if [[ -z ${skip} ]] ; then
1201 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1089 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1202 local skip=0 1090 local skip=0
1203 exe=tail 1091 exe=tail
1204 case ${ver} in 1092 case ${ver} in
1205 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1093 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1206 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1094 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1208 2.0|2.0.1) 1096 2.0|2.0.1)
1209 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1097 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1210 ;; 1098 ;;
1211 2.1.1) 1099 2.1.1)
1212 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1100 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1213 let skip="skip + 1" 1101 (( skip++ ))
1214 ;; 1102 ;;
1215 2.1.2) 1103 2.1.2)
1216 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1104 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1217 let skip="skip + 1" 1105 (( skip++ ))
1218 ;; 1106 ;;
1219 2.1.3) 1107 2.1.3)
1220 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1108 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1221 let skip="skip + 1" 1109 (( skip++ ))
1222 ;; 1110 ;;
1223 2.1.4|2.1.5) 1111 2.1.4|2.1.5)
1224 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1112 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1225 skip=$(head -n ${skip} "${src}" | wc -c) 1113 skip=$(head -n ${skip} "${src}" | wc -c)
1226 exe="dd" 1114 exe="dd"
1235 esac 1123 esac
1236 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1124 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1237 fi 1125 fi
1238 case ${exe} in 1126 case ${exe} in
1239 tail) exe="tail -n +${skip} '${src}'";; 1127 tail) exe="tail -n +${skip} '${src}'";;
1240 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1128 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1241 *) die "makeself cant handle exe '${exe}'" 1129 *) die "makeself cant handle exe '${exe}'"
1242 esac 1130 esac
1243 1131
1244 # lets grab the first few bytes of the file to figure out what kind of archive it is 1132 # lets grab the first few bytes of the file to figure out what kind of archive it is
1245 local tmpfile=$(emktemp) 1133 local filetype tmpfile=$(emktemp)
1246 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1134 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1247 local filetype=$(file -b "${tmpfile}") 1135 filetype=$(file -b "${tmpfile}") || die
1248 case ${filetype} in 1136 case ${filetype} in
1249 *tar\ archive*) 1137 *tar\ archive*)
1250 eval ${exe} | tar --no-same-owner -xf - 1138 eval ${exe} | tar --no-same-owner -xf -
1251 ;; 1139 ;;
1252 bzip2*) 1140 bzip2*)
1262 eerror "Unknown filetype \"${filetype}\" ?" 1150 eerror "Unknown filetype \"${filetype}\" ?"
1263 false 1151 false
1264 ;; 1152 ;;
1265 esac 1153 esac
1266 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1154 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1267}
1268
1269# @FUNCTION: check_license
1270# @USAGE: [license]
1271# @DESCRIPTION:
1272# Display a license for user to accept. If no license is
1273# specified, then ${LICENSE} is used.
1274check_license() {
1275 local lic=$1
1276 if [ -z "${lic}" ] ; then
1277 lic="${PORTDIR}/licenses/${LICENSE}"
1278 else
1279 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1280 lic="${PORTDIR}/licenses/${lic}"
1281 elif [ -e "${PWD}/${lic}" ] ; then
1282 lic="${PWD}/${lic}"
1283 elif [ -e "${lic}" ] ; then
1284 lic="${lic}"
1285 fi
1286 fi
1287 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1288 local l="`basename ${lic}`"
1289
1290 # here is where we check for the licenses the user already
1291 # accepted ... if we don't find a match, we make the user accept
1292 local shopts=$-
1293 local alic
1294 set -o noglob #so that bash doesn't expand "*"
1295 for alic in ${ACCEPT_LICENSE} ; do
1296 if [[ ${alic} == ${l} ]]; then
1297 set +o noglob; set -${shopts} #reset old shell opts
1298 return 0
1299 fi
1300 done
1301 set +o noglob; set -$shopts #reset old shell opts
1302
1303 local licmsg=$(emktemp)
1304 cat <<-EOF > ${licmsg}
1305 **********************************************************
1306 The following license outlines the terms of use of this
1307 package. You MUST accept this license for installation to
1308 continue. When you are done viewing, hit 'q'. If you
1309 CTRL+C out of this, the install will not run!
1310 **********************************************************
1311
1312 EOF
1313 cat ${lic} >> ${licmsg}
1314 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1315 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1316 read alic
1317 case ${alic} in
1318 yes|Yes|y|Y)
1319 return 0
1320 ;;
1321 *)
1322 echo;echo;echo
1323 eerror "You MUST accept the license to continue! Exiting!"
1324 die "Failed to accept license"
1325 ;;
1326 esac
1327} 1155}
1328 1156
1329# @FUNCTION: cdrom_get_cds 1157# @FUNCTION: cdrom_get_cds
1330# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...] 1158# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1331# @DESCRIPTION: 1159# @DESCRIPTION:
1379 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1207 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1380 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1208 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1381 export CDROM_SET=-1 1209 export CDROM_SET=-1
1382 for f in ${CDROM_CHECK_1//:/ } ; do 1210 for f in ${CDROM_CHECK_1//:/ } ; do
1383 ((++CDROM_SET)) 1211 ((++CDROM_SET))
1384 [[ -e ${CD_ROOT}/${f} ]] && break 1212 [[ -e ${CDROM_ROOT}/${f} ]] && break
1385 done 1213 done
1386 export CDROM_MATCH=${f} 1214 export CDROM_MATCH=${f}
1387 return 1215 return
1388 fi 1216 fi
1389 1217
1553# of the lists. 1381# of the lists.
1554strip-linguas() { 1382strip-linguas() {
1555 local ls newls nols 1383 local ls newls nols
1556 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1384 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1557 local op=$1; shift 1385 local op=$1; shift
1558 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1386 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1559 local d f 1387 local d f
1560 for d in "$@" ; do 1388 for d in "$@" ; do
1561 if [[ ${op} == "-u" ]] ; then 1389 if [[ ${op} == "-u" ]] ; then
1562 newls=${ls} 1390 newls=${ls}
1563 else 1391 else
1564 newls="" 1392 newls=""
1565 fi 1393 fi
1566 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1394 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1567 if [[ ${op} == "-i" ]] ; then 1395 if [[ ${op} == "-i" ]] ; then
1568 hasq ${f} ${ls} && newls="${newls} ${f}" 1396 has ${f} ${ls} && newls="${newls} ${f}"
1569 else 1397 else
1570 hasq ${f} ${ls} || newls="${newls} ${f}" 1398 has ${f} ${ls} || newls="${newls} ${f}"
1571 fi 1399 fi
1572 done 1400 done
1573 ls=${newls} 1401 ls=${newls}
1574 done 1402 done
1575 else 1403 else
1577 fi 1405 fi
1578 1406
1579 nols="" 1407 nols=""
1580 newls="" 1408 newls=""
1581 for f in ${LINGUAS} ; do 1409 for f in ${LINGUAS} ; do
1582 if hasq ${f} ${ls} ; then 1410 if has ${f} ${ls} ; then
1583 newls="${newls} ${f}" 1411 newls="${newls} ${f}"
1584 else 1412 else
1585 nols="${nols} ${f}" 1413 nols="${nols} ${f}"
1586 fi 1414 fi
1587 done 1415 done
1588 [[ -n ${nols} ]] \ 1416 [[ -n ${nols} ]] \
1589 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1417 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1590 export LINGUAS=${newls:1} 1418 export LINGUAS=${newls:1}
1591} 1419}
1592 1420
1593# @FUNCTION: preserve_old_lib 1421# @FUNCTION: preserve_old_lib
1594# @USAGE: <libs to preserve> [more libs] 1422# @USAGE: <libs to preserve> [more libs]
1642 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1470 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1643 ewarn "in order to remove these old dependencies. If you do not have this" 1471 ewarn "in order to remove these old dependencies. If you do not have this"
1644 ewarn "helper program, simply emerge the 'gentoolkit' package." 1472 ewarn "helper program, simply emerge the 'gentoolkit' package."
1645 ewarn 1473 ewarn
1646 fi 1474 fi
1475 # temp hack for #348634 #357225
1476 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1647 ewarn " # revdep-rebuild --library ${lib##*/}" 1477 ewarn " # revdep-rebuild --library '${lib}'"
1648 done 1478 done
1649 if [[ ${notice} -eq 1 ]] ; then 1479 if [[ ${notice} -eq 1 ]] ; then
1650 ewarn 1480 ewarn
1651 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1481 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1652 ewarn "delete the old libraries. Here is a copy & paste for the lazy:" 1482 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1657} 1487}
1658 1488
1659# @FUNCTION: built_with_use 1489# @FUNCTION: built_with_use
1660# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1490# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1661# @DESCRIPTION: 1491# @DESCRIPTION:
1492#
1493# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1494#
1662# A temporary hack until portage properly supports DEPENDing on USE 1495# A temporary hack until portage properly supports DEPENDing on USE
1663# flags being enabled in packages. This will check to see if the specified 1496# flags being enabled in packages. This will check to see if the specified
1664# DEPEND atom was built with the specified list of USE flags. The 1497# DEPEND atom was built with the specified list of USE flags. The
1665# --missing option controls the behavior if called on a package that does 1498# --missing option controls the behavior if called on a package that does
1666# not actually support the defined USE flags (aka listed in IUSE). 1499# not actually support the defined USE flags (aka listed in IUSE).
1794 ) || die 1627 ) || die
1795 else 1628 else
1796 newbin "${tmpwrapper}" "${wrapper}" || die 1629 newbin "${tmpwrapper}" "${wrapper}" || die
1797 fi 1630 fi
1798} 1631}
1632
1633# @FUNCTION: path_exists
1634# @USAGE: [-a|-o] <paths>
1635# @DESCRIPTION:
1636# Check if the specified paths exist. Works for all types of paths
1637# (files/dirs/etc...). The -a and -o flags control the requirements
1638# of the paths. They correspond to "and" and "or" logic. So the -a
1639# flag means all the paths must exist while the -o flag means at least
1640# one of the paths must exist. The default behavior is "and". If no
1641# paths are specified, then the return value is "false".
1642path_exists() {
1643 local opt=$1
1644 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1645
1646 # no paths -> return false
1647 # same behavior as: [[ -e "" ]]
1648 [[ $# -eq 0 ]] && return 1
1649
1650 local p r=0
1651 for p in "$@" ; do
1652 [[ -e ${p} ]]
1653 : $(( r += $? ))
1654 done
1655
1656 case ${opt} in
1657 -a) return $(( r != 0 )) ;;
1658 -o) return $(( r == $# )) ;;
1659 esac
1660}
1661
1662# @FUNCTION: in_iuse
1663# @USAGE: <flag>
1664# @DESCRIPTION:
1665# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1666# as necessary.
1667#
1668# Note that this function should not be used in the global scope.
1669in_iuse() {
1670 debug-print-function ${FUNCNAME} "${@}"
1671 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1672
1673 local flag=${1}
1674 local liuse=( ${IUSE} )
1675
1676 has "${flag}" "${liuse[@]#[+-]}"
1677}
1678
1679# @FUNCTION: use_if_iuse
1680# @USAGE: <flag>
1681# @DESCRIPTION:
1682# Return true if the given flag is in USE and IUSE.
1683#
1684# Note that this function should not be used in the global scope.
1685use_if_iuse() {
1686 in_iuse $1 || return 1
1687 use $1
1688}
1689
1690# @FUNCTION: usex
1691# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1692# @DESCRIPTION:
1693# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1694# otherwise echo [false output][false suffix] (defaults to "no").
1695usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1696
1697check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1698
1699fi

Legend:
Removed from v.1.302  
changed lines
  Added in v.1.373

  ViewVC Help
Powered by ViewVC 1.1.20